
#include "NvSockManager.h"
#include "NvListenSocket.h"
#include <process.h>
#include <stdio.h>

CNvSockManager::CNvSockManager()
{
	m_nSockCount = 0;
	m_hThread = NULL;
	m_bRunning = false;

	for(int i = 0; i < 64; ++i)
	{
		m_arrSocket[i] = NULL;
	}
}

CNvSockManager::~CNvSockManager()
{

}

CNvListenSocket server;
bool CNvSockManager::Start()
{
	m_bRunning = true;

	CNvSockAddr address;
	address.SetAddrPort(INADDR_ANY, 14591);

	CNvListenSocketEventSink listenSocketEventSink;
	server.Advise(&listenSocketEventSink);

	server.Create(&address);
	server.Listen();

	m_hThread = (HANDLE)_beginthread(run0,0,this);

	WaitForSingleObject(m_hThread, INFINITE );
	return true;
}

void CNvSockManager::Stop()
{
	m_bRunning = false;
	_endthread();
}

bool CNvSockManager::AddSocket(CNvTcpSocket *pSocket)
{
	for(int i = 0; i < 64; ++i)
	{
		if(m_arrSocket[i] == NULL)
		{
			m_arrSocket[i] = pSocket;
			++m_nSockCount;
			return true;
		}
	}
	return false;
}

void CNvSockManager::RemoveSocket(CNvTcpSocket *pSocket)
{
	for(int i = 0; i < 64; ++i)
	{
		if(m_arrSocket[i] == pSocket)
		{
			if(m_arrSocket[i] != NULL)
			{
				delete m_arrSocket[i];
			}
			m_arrSocket[i] = NULL;
			--m_nSockCount;
		}
	}
}

int CNvSockManager::GetSocketNumber()
{
	for(int i = 0; i < 64; ++i)
	{
		if(m_arrSocket[i] == NULL)
		{
			return i;
		}
	}
	return 64;
}


void CNvSockManager::Run(void *pParam)
{
	while(1)
	{
		FD_ZERO(&m_fdReadSet);
		FD_ZERO(&m_fdWriteSet);
		FD_ZERO(&m_fdErrSet);

		FD_SET(server.GetSocketID(), &m_fdReadSet);

		for(int i = 0; i < 64; i++) 
		{
			if(m_arrSocket[i] == NULL)
			{
				continue;
			}
			
			FD_SET(m_arrSocket[i]->GetSocketID(), &m_fdReadSet);
			FD_SET(m_arrSocket[i]->GetSocketID(), &m_fdWriteSet);
		}

		if(select(server.GetSocketID(),&m_fdReadSet, &m_fdWriteSet, &m_fdErrSet, (struct timeval *) 0) < 0)     /* select setting */
		{
			printf("select error =< 0 \n");
			exit(0);
		}

		struct sockaddr_in clientaddr;
		int addrlen;
		int client_sock;
        //   ˻(1): Ŭ̾Ʈ  
        if(FD_ISSET(server.GetSocketID(), &m_fdReadSet)) {
			addrlen = sizeof(clientaddr);
            client_sock = accept(server.GetSocketID(), (SOCKADDR *)&clientaddr, &addrlen);

			//m_arrSocket[GetSocketNumber()] = new CNvTcpSocket;
			//CNvTcpSocket *clientSocket = m_arrSocket[GetSocketNumber()]
			CNvTcpSocket *clientSocket = new CNvTcpSocket;
			clientSocket->Create(client_sock);

	
			server.OnConnected(clientSocket);

            if(client_sock == INVALID_SOCKET) 
			{
                if(WSAGetLastError() != WSAEWOULDBLOCK)
				{
					printf("accept() error");
				}
            }
            else 
			{
                printf("[TCP ] Ŭ̾Ʈ : IP ּ=%s, Ʈ ȣ=%d\n",
					inet_ntoa(clientaddr.sin_addr), ntohs(clientaddr.sin_port));
                //   ߰
                if(AddSocket(clientSocket) == false) 
				{
                    printf("[TCP ] Ŭ̾Ʈ  մϴ!\n");
                    closesocket(client_sock);
                }
            }
        }
		//   ˻(2):  
		for(int i=0; i < 64; i++) 
		{
			if(m_arrSocket[i] == NULL)
			{
				continue;
			}

//			FD_SET(m_arrSocket[i]->GetSocketID(), &m_fdReadSet);
			if(FD_ISSET(m_arrSocket[i]->GetSocketID(), &m_fdReadSet)) 
			{
				//  ޱ
				char message[256];
				int retval = recv(m_arrSocket[i]->GetSocketID(), message, 256, 0);
				if(retval == SOCKET_ERROR) 
				{
					if(WSAGetLastError() != WSAEWOULDBLOCK) 
					{
						printf("recv() error");
						RemoveSocket(m_arrSocket[i]);
					}
					continue;
				}
				else if(retval == 0) 
				{
					RemoveSocket(m_arrSocket[i]);
					continue;
				}
				//ptr->recvbytes = retval;
				//   
				addrlen = sizeof(clientaddr);
				getpeername(m_arrSocket[i]->GetSocketID(), (SOCKADDR *)&clientaddr, &addrlen);
				message[retval] = '\0';
				char sendMessage[512];
				sprintf_s(sendMessage, "[TCP/%s:%d] %s\n", inet_ntoa(clientaddr.sin_addr), ntohs(clientaddr.sin_port), message);
				printf(sendMessage);

				for(int j=0; j < 64; j++) 
				{
					if(m_arrSocket[j] == NULL && i != j)
					{
						continue;
					}

//					FD_SET(m_arrSocket[j]->GetSocketID(), &m_fdWriteSet);
					if(FD_ISSET(m_arrSocket[j]->GetSocketID(), &m_fdWriteSet)) 
					{
						//  
						retval = send(m_arrSocket[j]->GetSocketID(), sendMessage, strlen(sendMessage), 0);
						if(retval == SOCKET_ERROR) 
						{
							if(WSAGetLastError() != WSAEWOULDBLOCK) {
								printf("send() error\n");
								RemoveSocket(m_arrSocket[i]);
							}
							continue;
						}
						//ptr->sendbytes += retval;

						//if(ptr->recvbytes == ptr->sendbytes) {   ptr->recvbytes = ptr->sendbytes = 0;     }
					}
				}
			}
		}
	}
}