
#include "NvClientSocket.h"
#include <stdio.h>
#include <process.h>

CNvTcpSocket tcpSocket;

CNvClientSocket::CNvClientSocket()
{
}

CNvClientSocket::~CNvClientSocket()
{
}

int CNvClientSocket::GetSocketID()
{
	return m_nSocketID;
}

bool CNvClientSocket::Create()
{
	WSADATA wsaData;
	if(WSAStartup(MAKEWORD(2, 2), &wsaData) != 0) /* Load Winsock 2.2 DLL */
	{
		return false;
	}
	if((m_nSocketID = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP)) < 0)
	{
		return false;
	}
	tcpSocket.Create(m_nSocketID);
	m_nSocketID = tcpSocket.GetSocketID();
	return true;
}

bool CNvClientSocket::Connect(CNvSockAddr *pRemoteAddr)
{
	tcpSocket.Connect(pRemoteAddr);
	return true;
}

int CNvClientSocket::Read(char *message, int maxSize)
{
	return tcpSocket.Read(message, maxSize);
}

int CNvClientSocket::Write(char *message, int maxSize)
{
	return tcpSocket.Write(message, maxSize);
}

void CNvClientSocket::Close()
{
	WSACleanup();
}


CNvClientSocket client;
void run0(void *pParam)
{
	while(1)
	{
		char message[256];
		memset(message, NULL, 256);
		if(client.Read(&message[0], 256) > 0)
		{
			printf("%s", message);
		}
	}
}

void main()
{
	HANDLE m_hThread = (HANDLE)_beginthread(run0,0,0);

	CNvSockAddr address;
	address.Create("192.168.0.4", 14591);

	client.Create();
	client.Connect(&address);

	while(1)
	{
		char message[256];
		scanf("%s", &message);
		client.Write(&message[0], strlen(message));
	}

	WaitForSingleObject(m_hThread, INFINITE );
}
