#ifndef _NVCLIENT_SOCKET_H_
#define _NVCLIENT_SOCKET_H_

#include "NvSockAddr.h"
#include "NvTcpSocket.h"

class CNvTcpSocket;

interface INvClientSocket
{
	virtual int GetSocketID() = 0;

	virtual bool Create() = 0;
	virtual bool Connect(CNvSockAddr *pRemoteAddr) = 0;
	virtual int Read(char *message, int maxSize) = 0;
	virtual int Write(char *message, int maxSize) = 0;

	virtual void Close() = 0;
};

class CNvClientSocket:public INvClientSocket
{
public:
	CNvClientSocket(void);
	virtual ~CNvClientSocket(void);

	virtual int GetSocketID();
	
	virtual bool Create();
	virtual bool Connect(CNvSockAddr *pRemoteAddr);
	virtual int Read(char *message, int maxSize);
	virtual int Write(char *message, int maxSize);

	virtual void Close();
protected:
	int m_nSocketID;
};
#endif