
#include "NvSockAddr.h"

CNvSockAddr::CNvSockAddr()
{
}

CNvSockAddr::~CNvSockAddr()
{

}

bool CNvSockAddr::Create(const char *pHostName,int nPort)
{
	struct hostent *hostAddr;

	memset(&m_Address, 0, sizeof(m_Address));

	m_Address.sin_family = AF_INET;

	if(pHostName[0] > 47  && pHostName[0] < 58) // IP Address
	{
		m_Address.sin_addr.s_addr = inet_addr(pHostName);
	}
	else // Host name
	{
		hostAddr = gethostbyname(pHostName); 
		m_Address.sin_addr = *((struct in_addr *)hostAddr->h_addr);
	}

	if(m_Address.sin_addr.s_addr == INADDR_NONE)
	{
		return false;
	}
	m_Address.sin_port = htons(nPort);

	return true;
}

void CNvSockAddr::SetAddrPort(unsigned int dwAddress,int nPort)
{
	memset(&m_Address, 0, sizeof(m_Address));

	m_Address.sin_family = AF_INET;
	m_Address.sin_addr.s_addr = htonl(dwAddress);
	m_Address.sin_port = htons(nPort);
}

unsigned int CNvSockAddr::GetAddress()
{
	return ntohl(m_Address.sin_addr.s_addr);	
}

int CNvSockAddr::GetPort()
{
	return ntohs(m_Address.sin_port);
}

void CNvSockAddr::GetSockAddr(sockaddr_in& rSockAddr)
{
	rSockAddr = m_Address;
}