#ifndef _NvSockAddr
#define _NvSockAddr

#pragma comment(lib, "wsock32.lib")

#include <winsock2.h>

/* Define interface */
#ifndef interface
	#define interface struct
#endif

interface INvSockAddr
{
	virtual bool Create(const char *pHostName,int nPort) = 0;
	virtual void SetAddrPort(unsigned int dwAddress,int nPort) = 0; 
	virtual unsigned int GetAddress() = 0;
	virtual int GetPort() = 0;
	virtual void GetSockAddr(sockaddr_in& rSockAddr) = 0;
};

class CNvSockAddr:public INvSockAddr
{
public:
	CNvSockAddr();
	virtual ~CNvSockAddr();

	/* Set name/address and port. e.g) Create("www.naver.com",80),Create("220.11.21.11",80)*/
	virtual bool Create(const char *pHostName,int nPort);
	/* Set name and port. e.g) Create("www.naver.com,80)*/
	
	/* @dwAddress: Host order IPv4 Address, 
	   @nPort :Host order Port */
	virtual void SetAddrPort(unsigned int dwAddress,int nPort); 
	
	/* 
		@return : host order IPv4 Address

	virtual */
	unsigned int GetAddress();

	/* 
	@return : host order IPv4 Address

	*/

	virtual int GetPort();

	virtual void GetSockAddr(sockaddr_in& rSockAddr);
protected:
	sockaddr_in	m_Address;
};

#endif
