#ifndef _TCP_SOCKET_H_
#define _TCP_SOCKET_H_

#include "NvSockAddr.h"

interface INvTcpSocket
{
	/* To get socket id  */
	virtual int GetSocketID() = 0;
	/*
		To create socket id. If pLocalAddrPort is not NULL, you must bind pLocalAddrPort to socket id
	*/
	virtual bool Create(CNvSockAddr *pLocalAddrPort = NULL) = 0;

	/* To create a new socket from accepted socket id */
	virtual bool Create(int nSocketID) = 0;

	/*		To connect a remote address and port	*/
	virtual bool Connect(CNvSockAddr *pRemoteAddrPort) = 0;

	/*	To receive data stream from the TCP socket	*/
	virtual int	 Read(char *pData,int nMaxSize) = 0;
	/*	To send data stream into the TCP socket	*/
	virtual int	 Write(char *pData,int nSize) = 0;


	/* To get a latest error code */
	virtual int	 GetLastError() = 0;

	/* To close this socket */
	virtual void Close() = 0;
};


class CNvTcpSocket:public INvTcpSocket
{
public:
	CNvTcpSocket(void);
	virtual ~CNvTcpSocket(void);

	virtual bool Create(CNvSockAddr *pLocalAddrPort/* = NULL*/);
	virtual bool Create(int nSocketID);

	virtual int GetSocketID();

	virtual bool Connect(CNvSockAddr *pRemoteAddrPort);

	virtual int	 Read(char *pData,int nMaxSize);
	virtual int	 Write(char *pData,int nSize);

	virtual int	 GetLastError();

	virtual void Close();
protected:
	int m_nSocketID;

	/* for future use, Don't implement this */
	//bool m_bReadReady;
	//bool m_bWriteReady;

	//char *m_pBuffer;
	//int  m_nLength;
};

#endif